From a5f70125125a0e9f69c1bb8687e9e3bdc98dd489 Mon Sep 17 00:00:00 2001
From: Hubert Zhang <hzhang@pivotal.io>
Date: Mon, 3 Sep 2018 09:40:09 +0000
Subject: [PATCH] WIP: Add disk quota feature.

Support native SQL for create/drop disk quota setting
Add disk quota launcher and worker process to monitor
the disk usage for each table/schema/role
Add enforcement when quota limit is exceeded.
---
 src/backend/catalog/Makefile               |    2 +-
 src/backend/commands/Makefile              |    2 +-
 src/backend/commands/diskquotacmd.c        |  223 ++++
 src/backend/commands/event_trigger.c       |    1 +
 src/backend/executor/execMain.c            |    6 +
 src/backend/nodes/copyfuncs.c              |   31 +
 src/backend/nodes/equalfuncs.c             |   26 +
 src/backend/parser/gram.y                  |   91 +-
 src/backend/postmaster/Makefile            |    2 +-
 src/backend/postmaster/diskquota.c         | 1810 ++++++++++++++++++++++++++++
 src/backend/postmaster/pgstat.c            |   20 +
 src/backend/postmaster/postmaster.c        |  251 +++-
 src/backend/storage/ipc/ipci.c             |    3 +
 src/backend/storage/lmgr/lwlocknames.txt   |    1 +
 src/backend/storage/lmgr/proc.c            |    9 +-
 src/backend/tcop/postgres.c                |   12 +
 src/backend/tcop/utility.c                 |   26 +
 src/backend/utils/adt/dbsize.c             |   17 +
 src/backend/utils/cache/syscache.c         |   34 +
 src/backend/utils/init/miscinit.c          |    5 +-
 src/backend/utils/init/postinit.c          |   19 +-
 src/backend/utils/misc/guc.c               |   40 +
 src/bin/psql/tab-complete.c                |    1 +
 src/include/catalog/indexing.h             |    8 +
 src/include/catalog/pg_diskquota.h         |   60 +
 src/include/commands/diskquotacmd.h        |   30 +
 src/include/nodes/nodes.h                  |    2 +
 src/include/nodes/parsenodes.h             |   32 +
 src/include/parser/kwlist.h                |    2 +
 src/include/pgstat.h                       |    3 +
 src/include/postmaster/diskquota.h         |   72 ++
 src/include/storage/pmsignal.h             |    2 +
 src/include/utils/dbsize.h                 |   18 +
 src/include/utils/guc_tables.h             |    1 +
 src/include/utils/syscache.h               |    3 +
 src/test/regress/expected/disk_quota.out   |   47 +
 src/test/regress/expected/sanity_check.out |    2 +
 src/test/regress/parallel_schedule         |    2 +-
 src/test/regress/serial_schedule           |    1 +
 src/test/regress/sql/disk_quota.sql        |   54 +
 40 files changed, 2933 insertions(+), 38 deletions(-)
 create mode 100644 src/backend/commands/diskquotacmd.c
 create mode 100644 src/backend/postmaster/diskquota.c
 create mode 100644 src/include/catalog/pg_diskquota.h
 create mode 100644 src/include/commands/diskquotacmd.h
 create mode 100644 src/include/postmaster/diskquota.h
 create mode 100644 src/include/utils/dbsize.h
 create mode 100644 src/test/regress/expected/disk_quota.out
 create mode 100644 src/test/regress/sql/disk_quota.sql

diff --git a/src/backend/catalog/Makefile b/src/backend/catalog/Makefile
index 0865240..9e57fe5 100644
--- a/src/backend/catalog/Makefile
+++ b/src/backend/catalog/Makefile
@@ -46,7 +46,7 @@ CATALOG_HEADERS := \
 	pg_default_acl.h pg_init_privs.h pg_seclabel.h pg_shseclabel.h \
 	pg_collation.h pg_partitioned_table.h pg_range.h pg_transform.h \
 	pg_sequence.h pg_publication.h pg_publication_rel.h pg_subscription.h \
-	pg_subscription_rel.h
+	pg_subscription_rel.h pg_diskquota.h
 
 GENERATED_HEADERS := $(CATALOG_HEADERS:%.h=%_d.h) schemapg.h
 
diff --git a/src/backend/commands/Makefile b/src/backend/commands/Makefile
index 4a6c99e..d5a3ebb 100644
--- a/src/backend/commands/Makefile
+++ b/src/backend/commands/Makefile
@@ -14,7 +14,7 @@ include $(top_builddir)/src/Makefile.global
 
 OBJS = amcmds.o aggregatecmds.o alter.o analyze.o async.o cluster.o comment.o \
 	collationcmds.o constraint.o conversioncmds.o copy.o createas.o \
-	dbcommands.o define.o discard.o dropcmds.o \
+	dbcommands.o define.o discard.o diskquotacmd.o dropcmds.o \
 	event_trigger.o explain.o extension.o foreigncmds.o functioncmds.o \
 	indexcmds.o lockcmds.o matview.o operatorcmds.o opclasscmds.o \
 	policy.o portalcmds.o prepare.o proclang.o publicationcmds.o \
diff --git a/src/backend/commands/diskquotacmd.c b/src/backend/commands/diskquotacmd.c
new file mode 100644
index 0000000..b110e0e
--- /dev/null
+++ b/src/backend/commands/diskquotacmd.c
@@ -0,0 +1,223 @@
+/*-------------------------------------------------------------------------
+ *
+ * disk_quota.c
+ *	  support for disk quota in different level.
+ *
+ *
+ * Portions Copyright (c) 1996-2018, PostgreSQL Global Development Group
+ *
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres.h"
+
+#include "access/heapam.h"
+#include "access/htup_details.h"
+#include "catalog/dependency.h"
+#include "catalog/indexing.h"
+#include "catalog/namespace.h"
+#include "catalog/pg_diskquota.h"
+#include "commands/diskquotacmd.h"
+#include "miscadmin.h"
+#include "utils/acl.h"
+#include "utils/builtins.h"
+#include "utils/guc.h"
+#include "utils/lsyscache.h"
+#include "utils/rel.h"
+#include "utils/syscache.h"
+
+void CreateDiskQuota(CreateDiskQuotaStmt *stmt)
+{
+	Relation	disk_quota_rel;
+	Datum		quota_values[Natts_pg_diskquota];
+	bool		quota_nulls[Natts_pg_diskquota];
+	Oid			db_object_oid = InvalidOid;
+	Oid			disk_quota_oid = InvalidOid;
+	HeapTuple	tuple;
+	Oid			ownerId;
+	ListCell   *cell;
+	bool		quota_set = false;
+
+
+	disk_quota_rel = heap_open(DiskQuotaRelationId, RowExclusiveLock);
+
+
+	/* Must be super user */
+	if (!superuser())
+		ereport(ERROR,
+				(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
+				 errmsg("permission denied to create disk quota \"%s\"",
+						stmt->quotaname),
+				 errhint("Must be superuser to create a disk quota.")));
+
+	/* For dependency only */
+	ownerId = GetUserId();
+
+	/* Check that there is no disk quota entry with the same name */
+	if (OidIsValid(GetDiskQuotaOidByName(stmt->quotaname)))
+		ereport(ERROR,
+				(errcode(ERRCODE_DUPLICATE_OBJECT),
+				 errmsg("disk quota entry \"%s\" already exists",
+						stmt->quotaname)));
+
+	/*
+	 * Insert tuple into pg_diskquota
+	 */
+	memset(quota_values, 0, sizeof(quota_values));
+	memset(quota_nulls, false, sizeof(quota_nulls));
+
+	quota_values[Anum_pg_diskquota_quotaname - 1] =
+		DirectFunctionCall1(namein, CStringGetDatum(stmt->quotaname));
+
+	quota_values[Anum_pg_diskquota_quotatype - 1] = Int16GetDatum((int16) stmt->dbobjtype);
+
+	/*
+	 * Search for related database object OID
+	 */
+
+	switch (stmt->dbobjtype)
+	{
+		case DISK_QUOTA_TABLE:
+		{
+			db_object_oid = RangeVarGetRelidExtended(stmt->table, NoLock, RVR_MISSING_OK, NULL, NULL);
+
+			if (!OidIsValid(db_object_oid)){
+				if (stmt->table->schemaname)
+				{
+					ereport(ERROR, (errmsg("could not create disk quota, TABLE '%s.%s' does not exist",
+										stmt->table->schemaname, stmt->table->relname)));
+				}
+				else
+				{
+					ereport(ERROR, (errmsg("could not create disk quota, TABLE '%s' does not exist",
+										stmt->table->relname)));
+				}
+
+			}
+			break;
+		}
+		case DISK_QUOTA_SCHEMA:
+		{
+			db_object_oid = LookupNamespaceNoError(stmt->objname);
+
+			if (!OidIsValid(db_object_oid))
+			{
+
+				ereport(ERROR, (errmsg("could not create disk quota, SCHEMA '%s' does not exist",
+									stmt->objname)));
+
+			}
+			break;
+
+		}
+		case DISK_QUOTA_USER:
+		{
+			db_object_oid = get_role_oid(stmt->objname, true);
+
+			if (!OidIsValid(db_object_oid))
+			{
+				ereport(ERROR, (errmsg("could not create disk quota, USER '%s' does not exist",
+									stmt->objname)));
+
+			}
+			break;
+
+		}
+		default:
+		{
+			ereport(ERROR, (errmsg("could not create disk quota, Unknown DB OBJECT TYPE")));
+		}
+	}
+
+	quota_values[Anum_pg_diskquota_quotatargetoid - 1] = ObjectIdGetDatum(db_object_oid);
+
+	foreach(cell, stmt->options)
+	{
+		DefElem    *def = (DefElem *) lfirst(cell);
+
+		if (strcmp(def->defname, "quota") == 0 && quota_set == false)
+		{
+			int limitinMB;
+			const char *hintmsg;
+			if (!parse_int(strVal(def->arg), &limitinMB, GUC_UNIT_MB, &hintmsg))
+			{
+				ereport(ERROR,
+						(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+						 errmsg("invalid value for integer option \"%s\": %s",
+								def->defname, strVal(def->arg))));
+			}
+			quota_values[Anum_pg_diskquota_quotalimit- 1] = limitinMB;
+			quota_set = true;
+		}
+		else
+		{
+			if (quota_set)
+			{
+				ereport(ERROR,
+						(errmsg("duplicate quota settings")));
+
+			} else
+			{
+				ereport(ERROR,
+						(errcode(ERRCODE_UNDEFINED_OBJECT),
+						 errmsg("unknown disk quota option %s", def->defname)));
+			}
+
+		}
+	}
+
+
+	tuple = heap_form_tuple(disk_quota_rel->rd_att, quota_values, quota_nulls);
+
+	disk_quota_oid = CatalogTupleInsert(disk_quota_rel, tuple);
+
+	heap_freetuple(tuple);
+
+	recordDependencyOnOwner(DiskQuotaRelationId, disk_quota_oid, ownerId);
+
+	if (!quota_set) {
+		ereport(ERROR,
+			(errmsg("quota is not set in option"),
+			 errhint("Add quota='size' in option")));
+	}
+
+	heap_close(disk_quota_rel, RowExclusiveLock);
+}
+
+void DropDiskQuota(DropDiskQuotaStmt *stmt)
+{
+	Relation	disk_quota_rel;
+	HeapTuple	disk_quota_tuple;
+
+
+	disk_quota_rel = heap_open(DiskQuotaRelationId, RowExclusiveLock);
+
+	disk_quota_tuple = SearchSysCache1(DISKQUOTANAME, CStringGetDatum(stmt->quotaname));
+
+	if (!HeapTupleIsValid(disk_quota_tuple)) {
+		if (stmt->missing_ok)
+			return;
+		else
+		{
+			ereport(ERROR,
+				(errmsg("disk quota %s does not exist", stmt->quotaname)));
+		}
+	}
+
+	CatalogTupleDelete(disk_quota_rel, &disk_quota_tuple->t_self);
+
+	ReleaseSysCache(disk_quota_tuple);
+
+	heap_close(disk_quota_rel, RowExclusiveLock);
+}
+
+char *GetDiskQuotaName(Oid quotaid)
+{
+	return "none";
+}
+
+Oid GetDiskQuotaOidByName(const char *name)
+{
+	return GetSysCacheOid1(DISKQUOTANAME, CStringGetDatum(name));
+}
diff --git a/src/backend/commands/event_trigger.c b/src/backend/commands/event_trigger.c
index eecc85d..b2847f2 100644
--- a/src/backend/commands/event_trigger.c
+++ b/src/backend/commands/event_trigger.c
@@ -94,6 +94,7 @@ static event_trigger_support_data event_trigger_support[] = {
 	{"CONVERSION", true},
 	{"DATABASE", false},
 	{"DOMAIN", true},
+	{"DISK QUOTA", true},
 	{"EXTENSION", true},
 	{"EVENT TRIGGER", false},
 	{"FOREIGN DATA WRAPPER", true},
diff --git a/src/backend/executor/execMain.c b/src/backend/executor/execMain.c
index 85d9803..6717292 100644
--- a/src/backend/executor/execMain.c
+++ b/src/backend/executor/execMain.c
@@ -52,6 +52,7 @@
 #include "miscadmin.h"
 #include "optimizer/clauses.h"
 #include "parser/parsetree.h"
+#include "postmaster/diskquota.h"
 #include "rewrite/rewriteManip.h"
 #include "storage/bufmgr.h"
 #include "storage/lmgr.h"
@@ -585,6 +586,11 @@ ExecCheckRTPerms(List *rangeTable, bool ereport_on_violation)
 							   get_rel_name(rte->relid));
 			return false;
 		}
+
+		if (!CheckTableQuota(rte))
+		{
+			return false;
+		}
 	}
 
 	if (ExecutorCheckPerms_hook)
diff --git a/src/backend/nodes/copyfuncs.c b/src/backend/nodes/copyfuncs.c
index 7c8220c..25b91be 100644
--- a/src/backend/nodes/copyfuncs.c
+++ b/src/backend/nodes/copyfuncs.c
@@ -4072,6 +4072,31 @@ _copyAlterExtensionContentsStmt(const AlterExtensionContentsStmt *from)
 	return newnode;
 }
 
+static CreateDiskQuotaStmt *
+_copyCreateDiskQuotaStmt(const CreateDiskQuotaStmt *from)
+{
+	CreateDiskQuotaStmt *newnode = makeNode(CreateDiskQuotaStmt);
+
+	COPY_STRING_FIELD(quotaname);
+	COPY_SCALAR_FIELD(dbobjtype);
+	COPY_STRING_FIELD(objname);
+	COPY_NODE_FIELD(options);
+
+	return newnode;
+}
+
+static DropDiskQuotaStmt *
+_copyDropDiskQuotaStmt(const DropDiskQuotaStmt *from)
+{
+	DropDiskQuotaStmt *newnode = makeNode(DropDiskQuotaStmt);
+
+	COPY_STRING_FIELD(quotaname);
+	COPY_SCALAR_FIELD(missing_ok);
+
+	return newnode;
+}
+
+
 static CreateFdwStmt *
 _copyCreateFdwStmt(const CreateFdwStmt *from)
 {
@@ -5379,6 +5404,12 @@ copyObjectImpl(const void *from)
 		case T_AlterExtensionContentsStmt:
 			retval = _copyAlterExtensionContentsStmt(from);
 			break;
+		case T_CreateDiskQuotaStmt:
+			retval = _copyCreateDiskQuotaStmt(from);
+			break;
+		case T_DropDiskQuotaStmt:
+			retval = _copyDropDiskQuotaStmt(from);
+			break;
 		case T_CreateFdwStmt:
 			retval = _copyCreateFdwStmt(from);
 			break;
diff --git a/src/backend/nodes/equalfuncs.c b/src/backend/nodes/equalfuncs.c
index 378f2fa..30cdb14 100644
--- a/src/backend/nodes/equalfuncs.c
+++ b/src/backend/nodes/equalfuncs.c
@@ -1857,6 +1857,26 @@ _equalAlterExtensionContentsStmt(const AlterExtensionContentsStmt *a, const Alte
 }
 
 static bool
+_equalCreateDiskQuotaStmt(const CreateDiskQuotaStmt *a, const CreateDiskQuotaStmt *b)
+{
+	COMPARE_STRING_FIELD(quotaname);
+	COMPARE_SCALAR_FIELD(dbobjtype);
+	COMPARE_STRING_FIELD(objname);
+	COMPARE_NODE_FIELD(options);
+
+	return true;
+}
+
+static bool
+_equalDropDiskQuotaStmt(const DropDiskQuotaStmt *a, const DropDiskQuotaStmt *b)
+{
+	COMPARE_STRING_FIELD(quotaname);
+	COMPARE_SCALAR_FIELD(missing_ok);
+
+	return true;
+}
+
+static bool
 _equalCreateFdwStmt(const CreateFdwStmt *a, const CreateFdwStmt *b)
 {
 	COMPARE_STRING_FIELD(fdwname);
@@ -3438,6 +3458,12 @@ equal(const void *a, const void *b)
 		case T_AlterExtensionContentsStmt:
 			retval = _equalAlterExtensionContentsStmt(a, b);
 			break;
+		case T_CreateDiskQuotaStmt:
+			retval = _equalCreateDiskQuotaStmt(a, b);
+			break;
+		case T_DropDiskQuotaStmt:
+			retval = _equalDropDiskQuotaStmt(a, b);
+			break;
 		case T_CreateFdwStmt:
 			retval = _equalCreateFdwStmt(a, b);
 			break;
diff --git a/src/backend/parser/gram.y b/src/backend/parser/gram.y
index 4bd2223..e6395c1 100644
--- a/src/backend/parser/gram.y
+++ b/src/backend/parser/gram.y
@@ -258,6 +258,7 @@ static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
 		CreateDomainStmt CreateExtensionStmt CreateGroupStmt CreateOpClassStmt
 		CreateOpFamilyStmt AlterOpFamilyStmt CreatePLangStmt
 		CreateSchemaStmt CreateSeqStmt CreateStmt CreateStatsStmt CreateTableSpaceStmt
+		CreateDiskQuotaStmt DropDiskQuotaStmt
 		CreateFdwStmt CreateForeignServerStmt CreateForeignTableStmt
 		CreateAssertStmt CreateTransformStmt CreateTrigStmt CreateEventTrigStmt
 		CreateUserStmt CreateUserMappingStmt CreateRoleStmt CreatePolicyStmt
@@ -407,6 +408,10 @@ static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
 %type <node>	opt_publication_for_tables publication_for_tables
 %type <value>	publication_name_item
 
+%type <list>    quota_option_list
+%type <str>     obj_name
+%type <defelt>  quota_option_elem
+
 %type <list>	opt_fdw_options fdw_options
 %type <defelt>	fdw_option
 
@@ -625,7 +630,7 @@ static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
 
 	DATA_P DATABASE DAY_P DEALLOCATE DEC DECIMAL_P DECLARE DEFAULT DEFAULTS
 	DEFERRABLE DEFERRED DEFINER DELETE_P DELIMITER DELIMITERS DEPENDS DESC
-	DETACH DICTIONARY DISABLE_P DISCARD DISTINCT DO DOCUMENT_P DOMAIN_P
+	DETACH DICTIONARY DISABLE_P DISCARD DISK DISTINCT DO DOCUMENT_P DOMAIN_P
 	DOUBLE_P DROP
 
 	EACH ELSE ENABLE_P ENCODING ENCRYPTED END_P ENUM_P ESCAPE EVENT EXCEPT
@@ -666,7 +671,7 @@ static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
 	POSITION PRECEDING PRECISION PRESERVE PREPARE PREPARED PRIMARY
 	PRIOR PRIVILEGES PROCEDURAL PROCEDURE PROCEDURES PROGRAM PUBLICATION
 
-	QUOTE
+	QUOTA QUOTE
 
 	RANGE READ REAL REASSIGN RECHECK RECURSIVE REF REFERENCES REFERENCING
 	REFRESH REINDEX RELATIVE_P RELEASE RENAME REPEATABLE REPLACE REPLICA
@@ -863,6 +868,7 @@ stmt :
 			| CreateAssertStmt
 			| CreateCastStmt
 			| CreateConversionStmt
+			| CreateDiskQuotaStmt
 			| CreateDomainStmt
 			| CreateExtensionStmt
 			| CreateFdwStmt
@@ -898,6 +904,7 @@ stmt :
 			| DoStmt
 			| DropAssertStmt
 			| DropCastStmt
+			| DropDiskQuotaStmt
 			| DropOpClassStmt
 			| DropOpFamilyStmt
 			| DropOwnedStmt
@@ -4772,6 +4779,84 @@ AlterExtensionContentsStmt:
 /*****************************************************************************
  *
  *		QUERY:
+ *             CREATE DISK QUOTA name ON obj_type obj_name WITH options_list
+ *
+ *****************************************************************************/
+
+CreateDiskQuotaStmt: CREATE DISK QUOTA name ON TABLE qualified_name opt_with '(' quota_option_list ')'
+					{
+						 CreateDiskQuotaStmt *n = makeNode(CreateDiskQuotaStmt);
+						 n->quotaname = $4;
+						 n->dbobjtype = DISK_QUOTA_TABLE;
+						 n->table = $7;
+						 n->objname = NULL;
+						 n->options = $10;
+						 $$ = (Node *)n;
+					}
+					|  CREATE DISK QUOTA name ON SCHEMA obj_name opt_with '(' quota_option_list ')'
+					{
+						CreateDiskQuotaStmt *n = makeNode(CreateDiskQuotaStmt);
+						n->quotaname = $4;
+						n->dbobjtype = DISK_QUOTA_SCHEMA;
+						n->table = NULL;
+						n->objname = $7;
+						n->options = $10;
+						$$ = (Node *)n;
+					}
+					|  CREATE DISK QUOTA name ON USER obj_name opt_with '(' quota_option_list ')'
+					{
+						CreateDiskQuotaStmt *n = makeNode(CreateDiskQuotaStmt);
+						n->quotaname = $4;
+						n->dbobjtype = DISK_QUOTA_USER;
+						n->table = NULL;
+						n->objname = $7;
+						n->options = $10;
+						$$ = (Node *)n;
+					}
+			;
+
+obj_name:
+		ColLabel                              { $$ = $1; }
+	;
+
+quota_option_elem:
+		ColLabel '=' Sconst
+		{
+			$$ = makeDefElem($1, (Node *)makeString($3), @1);
+		}
+	;
+
+quota_option_list:
+		quota_option_elem                               { $$ = list_make1($1); }
+		| quota_option_list ',' quota_option_elem       { $$ = lappend($1, $3); }
+	;
+
+/*****************************************************************************
+ *
+ *		QUERY:
+ *             DROP DISK QUOTA name
+ *
+ *****************************************************************************/
+
+DropDiskQuotaStmt: DROP DISK QUOTA name
+					{
+						DropDiskQuotaStmt *n = makeNode(DropDiskQuotaStmt);
+						n->quotaname = $4;
+						n->missing_ok = false;
+						$$ = (Node *) n;
+					}
+					|  DROP DISK QUOTA IF_P EXISTS name
+					{
+						DropDiskQuotaStmt *n = makeNode(DropDiskQuotaStmt);
+						n->quotaname = $6;
+						n->missing_ok = true;
+						$$ = (Node *) n;
+					}
+	;
+
+/*****************************************************************************
+ *
+ *		QUERY:
  *             CREATE FOREIGN DATA WRAPPER name options
  *
  *****************************************************************************/
@@ -15072,6 +15157,7 @@ unreserved_keyword:
 			| DICTIONARY
 			| DISABLE_P
 			| DISCARD
+			| DISK
 			| DOCUMENT_P
 			| DOMAIN_P
 			| DOUBLE_P
@@ -15192,6 +15278,7 @@ unreserved_keyword:
 			| PROCEDURES
 			| PROGRAM
 			| PUBLICATION
+			| QUOTA
 			| QUOTE
 			| RANGE
 			| READ
diff --git a/src/backend/postmaster/Makefile b/src/backend/postmaster/Makefile
index 71c2321..a589325 100644
--- a/src/backend/postmaster/Makefile
+++ b/src/backend/postmaster/Makefile
@@ -13,6 +13,6 @@ top_builddir = ../../..
 include $(top_builddir)/src/Makefile.global
 
 OBJS = autovacuum.o bgworker.o bgwriter.o checkpointer.o fork_process.o \
-	pgarch.o pgstat.o postmaster.o startup.o syslogger.o walwriter.o
+	pgarch.o pgstat.o postmaster.o startup.o syslogger.o walwriter.o diskquota.o
 
 include $(top_srcdir)/src/backend/common.mk
